var MooSelect = Class.create();
	MooSelect.prototype = {
		initialize: function(node, return_to) {
			if (node && return_to) { 
				this.node = node; 
				this.return_to = return_to; 
				this.select_toggle(this.node); 
			} 
			this.body_el = document.body;
		},
		select_listen: function(event) {
			var el = event.target;
			if (!this.return_to.style.oldBackgroundColor) {
				this.return_to.style.oldBackgroundColor = this.return_to.style.backgroundColor;
			}
			
			// add the effect to all but the node that is the toggle element and the return_to element
			if (el != this.node && el != this.return_to) {
				this.return_to.color_complete = function() {
					if (!this.done) {
						this.toggle();
						this.done = true;
					}
				};
				
				if (el.id && this.return_to.value != el.id) {
					this.return_to.value = el.id;
					this.return_to.color_success = new fx.Color(this.return_to, {toColor: "#00FF00", fromColor: "#FFFFFF", duration: 500, property: 'backgroundColor', onComplete: this.return_to.color_complete });	
					this.return_to.color_success.toggle();
				} else {
					 if (el.childNodes) {
					 	if (el.firstChild.id) {
					 		
					 	} else if (el.lastChild.id) {
					 		
					 	} else {
							for (var i = 0; i < el.childNodes.length; i++) {
								if (el.childNodes[i].id) {
									this.return_to.value = el.childNodes[i].id;
									this.return_to.color_success = new fx.Color(this.return_to, {toColor: "#00FF00", fromColor: "#FFFFFF", duration: 500, property: 'backgroundColor', onComplete: this.return_to.color_complete });	
									this.return_to.color_success.toggle();	
								}
							}
					 	}
					} else if (el.parentNode.id) {
						this.return_to.value = el.parentNode.id;
						this.return_to.color_success = new fx.Color(this.return_to, {toColor: "#00FF00", fromColor: "#FFFFFF", duration: 500, property: 'backgroundColor', onComplete: this.return_to.color_complete });	
						this.return_to.color_success.toggle();
					} else {
						this.return_to.value = "ID NOT FOUND";
						this.return_to.color_fail = new fx.Color(this.return_to, {toColor: "#FF0000", fromColor: "#FFFFFF", duration: 500, property: 'backgroundColor', onComplete: this.return_to.color_complete });	
						this.return_to.color_fail.toggle();
					}
				} 
			} 
		},
		
		select_on: function() {
			this.select_click();
		},
		
		select_off: function() {
			this.body_el.onclick = "";
			this.body_el.onmouseover = "";
		},
		
		select_click: function() {
			this.body_el.onclick = this.select_listen.bindAsEventListener(this);
			this.body_el.onmouseover = this.select_target_effects.bindAsEventListener(this);
		},
		
		select_target_effects: function(event) {
			var el = event.target;
				el.onmouseover = function() {
					if (!window.Element.hasClassName(el, "moo_select_hover")) {
						window.Element.addClassName(el, "moo_select_hover");
					}
				};
				el.onmouseout = function() {
					if (window.Element.hasClassName(el, "moo_select_hover")) {
						window.Element.removeClassName(el, "moo_select_hover");
					}
				};
	
		},
		
		select_toggle: function(node) {
			var __method = this;
			
			node.onclick = function() {
				if (!this.select_on) {
					__method.select_on();
					this.style.backgroundColor = "#00AA00";
					this.value = "Stop Find";
					this.select_on = true;
				} else {
					__method.select_off();
					this.style.background = "none";
					this.value = "Find";
					this.select_on = false;
				}
			};
		}
	}